



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>Django 系列博客（十三）</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">Django 系列博客（十三）</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-02-08 00:31:30 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<h1>Django 系列博客（十三）</h1>
<h2>前言</h2>
<p>本篇博客介绍 Django 中的常用字段和参数。</p>
<h2>ORM 字段</h2>
<h3>AutoField</h3>
<p>int 自增列，必须填入参数 primary_key=True。当 model 中如果没有自增列，则会自动创建一个列名为 id 的列。</p>
<h3>IntegerField</h3>
<p>一个整数类型，范围在-2147483648 to 2147483647。</p>
<h3>CharField</h3>
<p>字符类型，必须提供max_length参数， max_length表示字符长度。</p>
<h3>DateField</h3>
<p>日期字段，日期格式  YYYY-MM-DD，相当于Python中的datetime.date()实例。</p>
<h3>DateTimeField</h3>
<p>日期时间字段，格式 YYYY-MM-DD HH:MM[:ss[.uuuuuu]][TZ]，相当于Python中的datetime.datetime()实例。</p>
<h2>常用和非常用字段</h2>
<pre class="prettyprint linenums"><code>AutoField(Field)<br />
- int自增列，必须填入参数<br />
primary_key = True

BigAutoField(AutoField)<br />
- bigint自增列，必须填入参数<br />
primary_key = True

注：当model中如果没有自增列，则自动会创建一个列名为id的列<br />
from django.db import models

class UserInfo(models.Model):<br />
    # 自动创建一个列名为id的且为自增的整数列<br />
    username = models.CharField(max_length=32)

class Group(models.Model):<br />
    # 自定义自增列<br />
    nid = models.AutoField(primary_key=True)<br />
    name = models.CharField(max_length=32)

SmallIntegerField(IntegerField):<br />
- 小整数 - 32768 ～ 32767

PositiveSmallIntegerField(PositiveIntegerRelDbTypeMixin, IntegerField)<br />
- 正小整数<br />
0 ～ 32767<br />
IntegerField(Field)<br />
- 整数列(有符号的) - 2147483648 ～ 2147483647

PositiveIntegerField(PositiveIntegerRelDbTypeMixin, IntegerField)<br />
- 正整数<br />
0 ～ 2147483647

BigIntegerField(IntegerField):<br />
- 长整型(有符号的) - 9223372036854775808 ～ 9223372036854775807

BooleanField(Field)<br />
- 布尔值类型

NullBooleanField(Field):<br />
- 可以为空的布尔值

CharField(Field)<br />
- 字符类型<br />
- 必须提供max_length参数， max_length表示字符长度

TextField(Field)<br />
- 文本类型

EmailField(CharField)：<br />
- 字符串类型，Django<br />
Admin以及ModelForm中提供验证机制

IPAddressField(Field)<br />
- 字符串类型，Django<br />
Admin以及ModelForm中提供验证<br />
IPV4<br />
机制

GenericIPAddressField(Field)<br />
- 字符串类型，Django<br />
Admin以及ModelForm中提供验证<br />
Ipv4和Ipv6<br />
- 参数：<br />
protocol，用于指定Ipv4或Ipv6， 'both', &quot;ipv4&quot;, &quot;ipv6&quot;<br />
unpack_ipv4， 如果指定为True，则输入::ffff: 192.0<br />
.2<br />
.1<br />
时候，可解析为192<br />
.0<br />
.2<br />
.1，开启此功能，需要protocol = &quot;both&quot;

URLField(CharField)<br />
- 字符串类型，Django<br />
Admin以及ModelForm中提供验证<br />
URL

SlugField(CharField)<br />
- 字符串类型，Django<br />
Admin以及ModelForm中提供验证支持<br />
字母、数字、下划线、连接符（减号）

CommaSeparatedIntegerField(CharField)<br />
- 字符串类型，格式必须为逗号分割的数字

UUIDField(Field)<br />
- 字符串类型，Django<br />
Admin以及ModelForm中提供对UUID格式的验证

FilePathField(Field)<br />
- 字符串，Django<br />
Admin以及ModelForm中提供读取文件夹下文件的功能<br />
- 参数：<br />
path, 文件夹路径<br />
match = None, 正则匹配<br />
recursive = False, 递归下面的文件夹<br />
allow_files = True, 允许文件<br />
allow_folders = False, 允许文件夹

FileField(Field)<br />
- 字符串，路径保存在数据库，文件上传到指定目录<br />
- 参数：<br />
upload_to = &quot;&quot;<br />
上传文件的保存路径<br />
storage = None<br />
存储组件，默认django.core.files.storage.FileSystemStorage

ImageField(FileField)<br />
- 字符串，路径保存在数据库，文件上传到指定目录<br />
- 参数：<br />
upload_to = &quot;&quot;<br />
上传文件的保存路径<br />
storage = None<br />
存储组件，默认django.core.files.storage.FileSystemStorage<br />
width_field = None, 上传图片的高度保存的数据库字段名（字符串）<br />
height_field = None<br />
上传图片的宽度保存的数据库字段名（字符串）

DateTimeField(DateField)<br />
- 日期 + 时间格式<br />
YYYY - MM - DD<br />
HH: MM[:ss[.uuuuuu]][TZ]

DateField(DateTimeCheckMixin, Field)<br />
- 日期格式<br />
YYYY - MM - DD

TimeField(DateTimeCheckMixin, Field)<br />
- 时间格式<br />
HH: MM[:ss[.uuuuuu]]

DurationField(Field)<br />
- 长整数，时间间隔，数据库中按照bigint存储，ORM中获取的值为datetime.timedelta类型

FloatField(Field)<br />
- 浮点型

DecimalField(Field)<br />
- 10<br />
进制小数<br />
- 参数：<br />
max_digits，小数总长度<br />
decimal_places，小数位长度

BinaryField(Field)<br />
- 二进制类型<br />
</code></pre>
<h2>ORM字段与数据库实际字段的对应关系</h2>
<pre class="prettyprint linenums"><code>对应关系：<br />
    'AutoField': 'integer AUTO_INCREMENT',<br />
    'BigAutoField': 'bigint AUTO_INCREMENT',<br />
    'BinaryField': 'longblob',<br />
    'BooleanField': 'bool',<br />
    'CharField': 'varchar(%(max_length)s)',<br />
    'CommaSeparatedIntegerField': 'varchar(%(max_length)s)',<br />
    'DateField': 'date',<br />
    'DateTimeField': 'datetime',<br />
    'DecimalField': 'numeric(%(max_digits)s, %(decimal_places)s)',<br />
    'DurationField': 'bigint',<br />
    'FileField': 'varchar(%(max_length)s)',<br />
    'FilePathField': 'varchar(%(max_length)s)',<br />
    'FloatField': 'double precision',<br />
    'IntegerField': 'integer',<br />
    'BigIntegerField': 'bigint',<br />
    'IPAddressField': 'char(15)',<br />
    'GenericIPAddressField': 'char(39)',<br />
    'NullBooleanField': 'bool',<br />
    'OneToOneField': 'integer',<br />
    'PositiveIntegerField': 'integer UNSIGNED',<br />
    'PositiveSmallIntegerField': 'smallint UNSIGNED',<br />
    'SlugField': 'varchar(%(max_length)s)',<br />
    'SmallIntegerField': 'smallint',<br />
    'TextField': 'longtext',<br />
    'TimeField': 'time',<br />
    'UUIDField': 'char(32)',<br />
</code></pre>
<h2>ORM字段参数</h2>
<h3>null</h3>
<p>用于表示某个字段可以为空。</p>
<h3>unique</h3>
<p>如果设置 unique=True，则该字段在此表中必须是惟一的。</p>
<h3>db_index</h3>
<p>如果 db_index=True， 则代表着为此字段设置索引。</p>
<h3>default</h3>
<p>为该字段设置默认值。</p>
<h3>auto_now_add</h3>
<p>配置 auto_now_add=True，创建数据记录的时候会把当前时间添加到数据库。</p>
<h3>auto_now</h3>
<p>配置 auto_now=True，每次更新数据记录的时候会更新该字段。</p>
<h3>具体意思</h3>
<pre class="prettyprint linenums"><code>null                数据库中字段是否可以为空<br />
db_column           数据库中字段的列名<br />
db_tablespace<br />
default             数据库中字段的默认值<br />
primary_key         数据库中字段是否为主键<br />
db_index            数据库中字段是否可以建立索引<br />
unique              数据库中字段是否可以建立唯一索引<br />
unique_for_date     数据库中字段【日期】部分是否可以建立唯一索引<br />
unique_for_month    数据库中字段【月】部分是否可以建立唯一索引<br />
unique_for_year     数据库中字段【年】部分是否可以建立唯一索引

verbose_name        Admin中显示的字段名称<br />
blank               Admin中是否允许用户输入为空<br />
editable            Admin中是否可以编辑<br />
help_text           Admin中该字段的提示信息<br />
choices             Admin中显示选择框的内容，用不变动的数据放在内存中从而避免跨表操作<br />
                    如：gf = models.IntegerField(choices=[(0, '何穗'),(1, '大表姐'),],default=1)

error_messages      自定义错误信息（字典类型），从而定制想要显示的错误信息；<br />
                    字典健：null, blank, invalid, invalid_choice, unique, and unique_for_date<br />
                    如：{'null': &quot;不能为空.&quot;, 'invalid': '格式错误'}

validators          自定义错误验证（列表类型），从而定制想要的验证规则<br />
                    from django.core.validators import RegexValidator<br />
                    from django.core.validators import EmailValidator,URLValidator,DecimalValidator,\<br />
                    MaxLengthValidator,MinLengthValidator,MaxValueValidator,MinValueValidator<br />
                    如：<br />
                        test = models.CharField(<br />
                            max_length=32,<br />
                            error_messages={<br />
                                'c1': '优先错信息1',<br />
                                'c2': '优先错信息2',<br />
                                'c3': '优先错信息3',<br />
                            },<br />
                            validators=[<br />
                                RegexValidator(regex='root_\d+', message='错误了', code='c1'),<br />
                                RegexValidator(regex='root_112233\d+', message='又错误了', code='c2'),<br />
                                EmailValidator(message='又错误了', code='c3'), ]                )<br />
</code></pre>
<h2>关系字段</h2>
<h3>ForeignKey</h3>
<p>外键类型在ORM中用来表示外键关联关系，一般把ForeignKey字段设置在 '一对多'中'多'的一方。ForeignKey可以和其他表做关联关系同时也可以和自身做关联关系。</p>
<h4>to</h4>
<p>设置要关联的表</p>
<h4>to_field</h4>
<p>设置要关联的表的字段</p>
<h4>related_name</h4>
<p>反向查询时，使用的字段名，用于代替原反向查询时的'表名_set'。</p>
<pre class="prettyprint linenums"><code>publish = ForeignKey(Blog, related_name='booklist')<br />
</code></pre>
<h4>db_constraint</h4>
<p>是否在数据库中创建外键约束，默认为 True。</p>
<h3>OneToOneField</h3>
<p>一对一字段，通常使用一对一字段用来扩展已有字段。</p>
<p>一对一的关联关系多用在当一张表的不同字段查询频次差距过大的情况下，将本可以存储在一张表的字段拆开放置在两张表中，然后将两张表建立一对一的关联关系。</p>
<pre class="prettyprint linenums"><code>class Author(models.Model):<br />
    id = models.AutoField(primary_key=True)<br />
    name = models.CharField(max_length=32)<br />
    age = models.IntegerField(default=18)

class AuthorDetail(models.Model):<br />
    id = models.AutoField(primary_key=True)<br />
    addr = models.CharField(max_length=32)<br />
    author = models.OneToOneField(to=Author, to_field='id')<br />
</code></pre>
<h4>to</h4>
<p>设置要关联的表</p>
<h4>to_field</h4>
<p>设置要关联的字段。</p>
<h4>on_delete</h4>
<p>级联删除选项</p>
<h3>ManyToManyField</h3>
<p>用于表示多对多的关联关系。在数据库中通过第三张表来建立关联关系。</p>
<h4>to</h4>
<p>设置要关联的表</p>
<h4>related_name</h4>
<p>反向查询时，使用的字段名，用于代替原反向查询时的'表名_set'。</p>
<h4>symmetrical</h4>
<p>仅用于多对多自关联时，指定内部是否创建反向操作的字段。默认为 True。</p>
<pre class="prettyprint linenums"><code>class Person(models.Model):<br />
    name = models.CharField(max_length=16)<br />
    friends = models.ManyToManyField(&quot;self&quot;)<br />
</code></pre>
<p>此时，person 对象没有 person_set属性。</p>
<pre class="prettyprint linenums"><code>class Person(models.Model):<br />
    name = models.CharField(max_length=16)<br />
    friends = models.ManyToManyField(&quot;self&quot;, symmetrical=False)<br />
</code></pre>
<p>此时，person 对象可以使用 person_set 属性进行反向查询。</p>
<h4>through</h4>
<p>在使用 ManyToManyField 字段时，Django 将自动生成一张表来管理多对多的关联关系。但是当我们手动创建第三张表来管理多对多关系时，就需要通过 through 来指定第三张表的表名。</p>
<pre class="prettyprint linenums"><code>class Book(models.Model):<br />
    id = models.AutoField(primary_key=True)<br />
    name = models.CharField(max_length=32)<br />
    price = models.DecimalField(max_digits=5, decimal_places=2)<br />
    publish_date = models.DateField()<br />
    publish = models.ForeignKey(to='Publish', to_field='id')<br />
    authors = models.ManyToManyField(to='Author', through='Book2Author', through_fields=('book', 'author'))

class Author(models.Model):<br />
    id = models.AutoField(primary_key=True)<br />
    name = models.CharField(max_length=32)<br />
    gender = models.SmallIntegerField()<br />
    author_detail = models.OneToOneField(to='AuthorDetail', to_field='id', on_delete=models.CASCADE)

class Book2Author(models.Model):<br />
    id = models.AutoField(primary_key=True)<br />
    book = models.ForeignKey(to=Book)<br />
    author = models.ForeignKey(to=Author)<br />
</code></pre>
<h4>through_field</h4>
<p>设置要关联的字段：关联字段在Book2Author中，从这个表到Book 表，所以把 book 写在前面。</p>
<h4>db_table</h4>
<p>默认创建第三张表时，设置表的名字。</p>
<h2>多对多关联关系的三种方式</h2>
<h3>方式一：手动创建第三张表</h3>
<pre class="prettyprint linenums"><code>class Book(models.Model):<br />
    id = models.AutoField(primary_key=True)<br />
    name = models.CharField(max_length=32)<br />
    price = models.DecimalField(max_digits=5, decimal_places=2)<br />
    publish_date = models.DateField()<br />
    publish = models.ForeignKey(to='Publish', to_field='id')

class Author(models.Model):<br />
    id = models.AutoField(primary_key=True)<br />
    name = models.CharField(max_length=32)<br />
    gender = models.SmallIntegerField()<br />
    author_detail = models.OneToOneField(to='AuthorDetail', to_field='id', on_delete=models.CASCADE)

class Book2Author(models.Model):<br />
    id = models.AutoField(primary_key=True)<br />
    book = models.ForeignKey(to=Book)<br />
    author = models.ForeignKey(to=Author)<br />
</code></pre>
<h3>方式二：通过 ManyToManyField 自动创建第三张表</h3>
<pre class="prettyprint linenums"><code>class Book(models.Model):<br />
    id = models.AutoField(primary_key=True)<br />
    name = models.CharField(max_length=32)<br />
    price = models.DecimalField(max_digits=5, decimal_places=2)<br />
    publish_date = models.DateField()<br />
    publish = models.ForeignKey(to='Publish', to_field='id')<br />
    authors = models.ManyToManyField(to='Author')

class Author(models.Model):<br />
    id = models.AutoField(primary_key=True)<br />
    name = models.CharField(max_length=32)<br />
    gender = models.SmallIntegerField()<br />
    author_detail = models.OneToOneField(to='AuthorDetail', to_field='id', on_delete=models.CASCADE)<br />
</code></pre>
<h3>方式三：设置 ManyToManyField 并指定手动创建第三张表</h3>
<pre class="prettyprint linenums"><code>class Book(models.Model):<br />
    id = models.AutoField(primary_key=True)<br />
    name = models.CharField(max_length=32)<br />
    price = models.DecimalField(max_digits=5, decimal_places=2)<br />
    publish_date = models.DateField()<br />
    publish = models.ForeignKey(to='Publish', to_field='id')

class Author(models.Model):<br />
    id = models.AutoField(primary_key=True)<br />
    name = models.CharField(max_length=32)<br />
    gender = models.SmallIntegerField()<br />
    author_detail = models.OneToOneField(to='AuthorDetail', to_field='id', on_delete=models.CASCADE)

class Book2Author(models.Model):<br />
    id = models.AutoField(primary_key=True)<br />
    book = models.ForeignKey(to=Book)<br />
    author = models.ForeignKey(to=Author)<br />
</code></pre>
<p>当业务需要在第三张关系表中存储额外的字段时，就要使用第三种方式。</p>
<p>这样创建的第三张表无法使用 set、add、remove、clear方法来管理对多多关系，需要通过第三张表来进行增、删、改，查询一样。</p>
<h2>自定义字段</h2>
<pre class="prettyprint linenums"><code>class FixedCharField(models.Field):<br />
    &quot;&quot;&quot;<br />
    自定义的char类型的字段类<br />
    &quot;&quot;&quot;<br />
    def __init__(self, max_length, *args, **kwargs):<br />
        self.max_length = max_length<br />
        super(FixedCharField, self).__init__(max_length=max_length, *args, **kwargs)

    def db_type(self, connection):<br />
        &quot;&quot;&quot;<br />
        限定生成数据库表的字段类型为char，长度为max_length指定的值<br />
        &quot;&quot;&quot;<br />
        return 'char(%s)' % self.max_length

class Class(models.Model):<br />
    id = models.AutoField(primary_key=True)<br />
    title = models.CharField(max_length=25)<br />
    # 使用自定义的char类型的字段<br />
    cname = FixedCharField(max_length=25)<br />
</code></pre>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/r93yw5w8.html">oracle学习笔记&lpar;二&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/5qy10pjq.html">Range Sum Query - Mutable</a>
		</li>
						<li><a href="https://www.batexi.com/a/0qwlrez9.html">SQL SERVER 2012 从Enterprise Evaluation Edtion 升级到 Standard Edtion SP1</a>
		</li>
						<li><a href="https://www.batexi.com/a/o8o503l9.html">POJ 3463 有向图求次短路的长度及其方法数</a>
		</li>
						<li><a href="https://www.batexi.com/a/m964ojj8.html">【iOS】网络编程&colon;上传图片到服务器</a>
		</li>
						<li><a href="https://www.batexi.com/a/rqldd2x9.html">虚拟机CentOS-mini安装完成后的网络设置</a>
		</li>
						<li><a href="https://www.batexi.com/a/o8kye679.html">BZOJ1432 &lbrack;ZJOI2009&rsqb;Function</a>
		</li>
						<li><a href="https://www.batexi.com/a/qvv1z2xq.html">hdu 2096</a>
		</li>
						<li><a href="https://www.batexi.com/a/q7m7mwxq.html">BZOJ 1001&colon; &lbrack;BeiJing2006&rsqb;狼抓兔子 最小割</a>
		</li>
						<li><a href="https://www.batexi.com/a/9j056llq.html">Linux批量重命名</a>
		</li>
						<li><a href="https://www.batexi.com/a/q4yegpeq.html">python进阶--打包为exe文件</a>
		</li>
						<li><a href="https://www.batexi.com/a/950xnvv8.html">drupal THEME主要文件</a>
		</li>
						<li><a href="https://www.batexi.com/a/q2jx04v8.html">hdu&lowbar;2110&lowbar;Crisis of HDU&lpar;母函数&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/qljn1pk9.html">Mysql临时表的用法 - 51CTO&period;COM</a>
		</li>
						<li><a href="https://www.batexi.com/a/q2jg4dv8.html">3&period;bootstrap-组件</a>
		</li>
						<li><a href="https://www.batexi.com/a/8kp61gj9.html">走近webpack（5）--devtool及babel的使用</a>
		</li>
						<li><a href="https://www.batexi.com/a/qljrv5x9.html">WebRTC系列&lpar;1&rpar;-手把手教你实现一个浏览器拍照室Demo</a>
		</li>
						<li><a href="https://www.batexi.com/a/qwjg2wr8.html">Android序列化</a>
		</li>
						<li><a href="https://www.batexi.com/a/q25w60lq.html">Java CAS同步机制 原理详解（为什么并发环境下的COUNT自增操作不安全）&colon; Atomic原子类底层用的不是传统意义的锁机制，而是无锁化的CAS机制，通过CAS机制保证多线程修改一个数值的安全性。</a>
		</li>
						<li><a href="https://www.batexi.com/a/qlll250q.html">Linux编程 22 shell编程&lpar;输出和输入重定向，管道，数学运算命令，退出脚本状态码&rpar;</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/8me172oq.html">xshell登陆服务器步骤</a>
			</li>
						<li><a href="https://www.batexi.com/a/9502kv08.html">Jquery weui picker 支持label和value</a>
			</li>
						<li><a href="https://www.batexi.com/a/9rgv2zm8.html">&lbrack;AtCoder3856&rsqb;Ice Rink Game - 模拟</a>
			</li>
						<li><a href="https://www.batexi.com/a/qy1z7ljq.html">php代码进行跨域请求处理</a>
			</li>
						<li><a href="https://www.batexi.com/a/9geo7078.html">用Group by分组后&comma;取每组的前3条记录&comma;怎么取&quest;</a>
			</li>
						<li><a href="https://www.batexi.com/a/90m63no8.html">Linux系统如何添加IP别名</a>
			</li>
						<li><a href="https://www.batexi.com/a/9geo7ne8.html">【原创】C&num;  API 未能创建 SSL&sol;TLS 安全通道 问题解决</a>
			</li>
						<li><a href="https://www.batexi.com/a/8ojm7k5q.html">【转载】C&plus;&plus; ，C&num;数据类型对照</a>
			</li>
						<li><a href="https://www.batexi.com/a/qv14xz1q.html">harbor在谷歌云上搭建 日志</a>
			</li>
						<li><a href="https://www.batexi.com/a/qv14xojq.html">【RL-TCPnet网络教程】第28章    RL-TCPnet之DNS应用</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
